import { mdiSecurityNetwork } from "@mdi/js";
import Icon from "@mdi/react";
import DeleteIcon from "@mui/icons-material/Delete";

import {
  Avatar,
  IconButton,
  ListItem,
  ListItemAvatar,
  ListItemButton,
  ListItemText,
} from "@mui/material";
import { NWFilter } from "../../api/NWFilterApi";

export function NWFilterItem(p: {
  value?: NWFilter;
  onClick?: () => void;
  dense?: boolean;
  onDelete?: () => void;
}): React.ReactElement {
  const inner = (
    <>
      <ListItemAvatar>
        <Avatar>
          <Icon path={mdiSecurityNetwork} />
        </Avatar>
      </ListItemAvatar>
      <ListItemText
        primary={
          p.value
            ? `${p.value.name} (${p.value.chain?.protocol ?? "unspecified"})`
            : "Unspecified"
        }
        secondary={
          p.value &&
          `${p.value.rules.length} rules - ${p.value.join_filters.length} joint filters`
        }
      />
    </>
  );

  if (p.onClick)
    return (
      <ListItemButton onClick={p.onClick} dense={p.dense}>
        {inner}
      </ListItemButton>
    );

  return (
    <ListItem
      secondaryAction={
        p.onDelete ? (
          <IconButton onClick={p.onDelete}>
            <DeleteIcon />
          </IconButton>
        ) : undefined
      }
    >
      {inner}
    </ListItem>
  );
}
